/*
 * Copyright (c) 1997 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef lodactor_h
#define lodactor_h

#include <vtkOpenGLActor.h>

class vtkMapper;

// With vtk-2.0 this has to be subclassed from vtkOpenGLActor,
// otherwise actor won't render

class LODActor : public vtkOpenGLActor {
public:
  static LODActor *New() {return new LODActor;};
  LODActor();
  ~LODActor();

  void SetLODMapper(int level, vtkMapper*);
  vtkMapper* GetLODMapper(int level);
  virtual void Render(vtkRenderer* ren);
  //virtual void RenderOld(vtkRenderer* ren);
  void GetXY(int& ix, int& iy) { ix = x; iy = y; }
  void SetXY(int ix, int iy) { x = ix; y = iy; }
  static void SetFootprint(float*, float*);
  static void UseFootprint(int);
protected:
  vtkMapper* mappers[6];
  int x, y;
  static float fx[];
  static float fy[];
  static int usefootprint;
};

#endif
